function PR.GUI.MainDialog:k_any(key)
    if key == 115 then -- s
        PR.GUI.View = "Sector"
        PR.GUI.Refresh()
    elseif key == 102 then -- f
        PR.GUI.View = "Search"
        PR.GUI.Refresh()
    elseif key == 118 then -- v
        PR.GUI.View = "Universe"
        PR.GUI.Refresh()
    elseif key == 99 then -- c
        PR.GUI.View = "Config"
        PR.GUI.Refresh()
    else
        local command = gkinterface.GetCommandForKeyboardBind(key)
        if (command == "prospector") or (command == "pr") or (command == "ore") then
            PR.GUI.Close()
        end
    end
    return iup.CONTINUE
end

function PR.GUI.MainDialog:close_cb()
    PR.GUI.Close()
end

function PR.GUI.Btn_Top1:action()
    if PR.GUI.View == "Sector" then PR.GUI.DisplayedSector = 0 end
    PR.GUI.View = PR.GUI.GetNextInArray(PR.GUI.Views, PR.GUI.View)
    PR.GUI.Refresh()
end

function PR.GUI.Btn_Top2:action()
    if PR.GUI.View == "Universe" then
        if PR.Config.UniverseSort == "ByOre" then
            PR.Config.UniverseSort = "BySystem"
        else
            PR.Config.UniverseSort = "ByOre"
        end
    elseif PR.GUI.View == "Search" then
        local function nextOre()
            local orecount = PR.Ore.n
            for i = 1, orecount do
                if PR.Config.Search.Ore == PR.Ore[i].shortname then
                    if i == orecount then i = 1 else i = i + 1 end
                    PR.Config.Search.Ore = PR.Ore[i].shortname
                    return
                end
            end
        end

        nextOre()
    elseif PR.GUI.View == "Sector" then
        PR.Config.SectorSort = PR.GUI.GetNextInArray(PR.GUI.SectorSortOptions,
            PR.Config.SectorSort)
    elseif PR.GUI.View == "Config" then
        PR.Config.PrintToHUD = not PR.Config.PrintToHUD
    end
    PR.GUI.Refresh()
end

function PR.GUI.Btn_Top3:action()
    if PR.GUI.View == "Search" then
        PR.Config.Search.Area = PR.GUI.GetNextInArray(PR.GUI.Areas,
            PR.Config.Search.Area)
        PR.GUI.FetchNextSystem()
    elseif PR.GUI.View == "Config" then
        PR.Config.COLOR = not PR.Config.COLOR
    elseif (PR.GUI.View == "Sector") and (PR.Config.SectorSort == "ByOre") then
        if PR.GUI.OreSort > 0 then
            PR.GUI.OreSort = (PR.GUI.OreSort < PR.GUI.SectorOres.n) and
                (PR.GUI.OreSort + 1) or 1
            PR.GUI.Btn_Top3.title = PR.GUI.SectorOres[PR.GUI.OreSort].name
        end
    end
    PR.GUI.Refresh()
end

function PR.GUI.Btn_Top4:action()
    if PR.GUI.View == "Search" then
        PR.GUI.FetchNextSystem()
    elseif PR.GUI.View == "Config" then
        PR.Config.VerbosityLevel = (PR.Config.VerbosityLevel <
            #PR.GUI.VerbosityLevels) and (PR.Config.VerbosityLevel + 1) or 1
    elseif PR.GUI.View == "Sector" then
        if PR.GUI.DisplayedSector > 0 and
            (PR.GUI.DisplayedSector ~= PR.Sector) and
            (PR.GUI.DisplayedSector ~= NavRoute.GetFinalDestination()) then
            NavRoute.SetFinalDestination(PR.GUI.DisplayedSector)
            PR.Print("Navigation destination set to " ..
                ShortLocationStr(PR.GUI.DisplayedSector), true)
        elseif PR.GUI.DisplayedSector == PR.Sector then
            if PR.SingleSearchTarget > 0 then
                PR.SingleSearchStop()
            elseif PR.MiningBeamEquipped then
                if PR.GUI.ScanTop30Idx then
                    PR.GUI.ScanTop30Idx = false
                    PR.GUI.Btn_Top4.title = "Start Top30 Check"
                    PR.GUI.Btn_Top4.fgcolor = PR.GUI.Color.Button
                    return -- cancel here to avoid refreshing the list
                else
                    PR.GUI.ScanTop30Idx = 0
                    PR.ScannerOffSwitch()
                    PR.GUI.ScanTop30()
                end
            end
        end
    end
    PR.GUI.Refresh()
end

local function plus_minus(amount)
    local value = tonumber(PR.GUI.UserInput.value)
    if value then
        value = value + tonumber(amount)
        local idx = tonumber(PR.GUI.DisplayPanel.Value) or 0
        local limit = (idx > 0 and PR.GUI.EditableValuesUnit[idx] == "ms") and
            1 or 0
        if value < limit then value = limit end
        PR.GUI.UserInput.value = value
    end
end

function PR.GUI.Btn_Minus:action()
    plus_minus(PR.GUI.Btn_Minus.title)
end

function PR.GUI.Btn_Plus:action()
    plus_minus(PR.GUI.Btn_Plus.title)
end

function PR.GUI.DisplayPanel:click_cb(row, col)
    local function handle_row_highlight()
        local sel_row = tonumber(PR.GUI.DisplayPanel.sel_row)
        if sel_row > 0 then
            PR.GUI.DisplayPanel:setattribute("BGCOLOR", sel_row, 1,
                PR.GUI.DisplayPanel.bgcolor)
        end
        PR.GUI.DisplayPanel:setattribute("BGCOLOR", row, 1,
            PR.GUI.Color.RowHighlight)
        PR.GUI.DisplayPanel.sel_row = row
    end

    PR.GUI.DisplayPanel:setattribute("BGCOLOR", row, 1,
        PR.GUI.DisplayPanel.bgcolor)

    if PR.GUI.View == "Sector" and PR.GUI.DisplayedSector == PR.Sector and
        not PlayerInStation()
    then
        handle_row_highlight()
        PR.GUI.Btn_Top4.fgcolor = PR.GUI.Color.Red
        PR.GUI.Btn_Top4.title = "Stop Search"
        PR.GUI.ScanTop30Idx = false
        return PR.SingleSearchStart(PR.GUI.ListedItems[row])
    elseif PR.GUI.View == "Search" then
        if PR.GUI.ListedItems[row] then
            PR.GUI.View = "Sector"
            PR.GUI.DisplayedSector = PR.GUI.ListedItems[row]
            return PR.GUI.Refresh()
        end
    elseif PR.GUI.View == "Config" then
        local text = PR.GUI.DisplayPanel:getcell(row, col)
        if text and text:find("=") then
            handle_row_highlight()
            PR.GUI.UserInput.value = PR.Config[ PR.GUI.EditableValues[row] ]
            if PR.GUI.EditableValuesUnit[row] == "%" then
                PR.GUI.Btn_Plus.title = "+10"
                PR.GUI.Btn_Minus.title = "-10"
            else
                PR.GUI.Btn_Plus.title = "+100"
                PR.GUI.Btn_Minus.title = "-100"
            end
        end
    elseif PR.GUI.View == "Universe" and PR.Config.UniverseSort == "ByOre" and
        PR.GUI.ListedItems[row] ~= nil
    then
        PR.Config.Search = {
            Ore = PR.GUI.ListedItems[row].ore,
            Area = PR.SystemOwnership[PR.GUI.ListedItems[row].system],
            System = PR.GUI.ListedItems[row].system
        }
        PR.GUI.View = "Search"
        return PR.GUI.Refresh()
    end
end

function PR.GUI.DisplayPanel:edition_cb()
    return iup.IGNORE
end

function PR.GUI.Btn_Bottom1:action()
    if PR.GUI.View == "Config" then
        local sel_row = tonumber(PR.GUI.DisplayPanel.sel_row)
        if sel_row > 0 then
            local value = tonumber(PR.GUI.UserInput.value)
            local param = PR.GUI.EditableValues[sel_row] or ""
            if value then
                if param:find("SearchPercent_") and
                    PR.Config[param] ~= value
                then
                    PR.GUI.SystemData = {}
                    PR.RecreateAllSystemData()
                end
                local limit = (PR.GUI.EditableValuesUnit[sel_row] == "ms") and
                    1 or 0
                if value < limit then value = limit end
            end
            PR.Config[param] = value or PR.Config[param]
        end
    end
    PR.SaveConfigNow()
    if PR.GUI.View == "Config" then PR.GUI.RefreshConfigBox() end
end

function PR.GUI.Btn_Bottom2:action()
    PR.GUI.Close()
end

function PR.GUI.Btn_Bottom3:action()
    if PR.GUI.View == "Sector" then
        PR.GUI.ConfirmationDialog:popup(iup.CENTER, iup.CENTER)
    end
end

function PR.GUI.Btn_ConfirmationReset:action()
    if PR.ResetSector(PR.GUI.DisplayedSector) then
        PR.Print("All data for the current sector has been permanently reset.",
            true)
        PR.GUI.Refresh()
    else
        PR.Print("Sector data reset failed. This is a bug.", true)
    end
    return iup.CLOSE
end

function PR.GUI.Btn_ConfirmationCancel:action()
    return iup.CLOSE
end
