-- check equipped mining equipment
function PR.CheckEquipment()
    local beamqty = 0
    local totalheat = 0
    PR.ScanRange = 0
    PR.BeamAvgHeat = 0
    PR.ScannerEquipped = false
    PR.MiningBeamEquipped = false

    for _, itemid in ipairs(GetShipInventory(GetActiveShipID()).addons) do
        local item_typeid = GetInventoryItemType(itemid)
        local item_class = InvManager.GetInventoryItemParameter(item_typeid, "Class") or ""
        if item_class == "Scanner" then
            PR.ScannerEquipped = true
            PR.ScanRange = math.max(PR.ScanRange,
                tonumber(InvManager.GetInventoryItemParameter(item_typeid, "Range") or 500))
        elseif item_class == "MiningGun" then
            PR.MiningBeamEquipped = true
            beamqty = beamqty + 1
            local heat = InvManager.GetInventoryItemParameter(item_typeid, "HeatGeneration")
            if heat then totalheat = totalheat + heat * 100 end
        end
    end

    -- FIXME: this ignores heating reduction bonuses in play from number of
    -- beams on the same ship and number of beams in the group,  also we don't
    -- know if all equipped beams are active
    if beamqty > 0 then PR.BeamAvgHeat = totalheat / beamqty end

    -- detect if active ship is one with a built-in scanner
    local builtin_range = InvManager.GetInventoryItemParameter(
        GetInventoryItemType(GetActiveShipID()), "ScannerRange")
    if builtin_range then
        PR.ScannerEquipped = true
        PR.ScanRange = math.max(PR.ScanRange, builtin_range)
    end
end
